import javax.microedition.lcdui.*;
import java.util.*;

public class TranslateForm extends TextBox implements CommandListener { 
    Dictionary dictionary;
    TeachForm  teach;

    public TranslateForm(Dictionary dictionary, TeachForm teach, String word) { 
        super(Locale.PREFIX, word, Dictionary.MAX_LENGTH, TextField.ANY);
        this.dictionary = dictionary;
        this.teach = teach;
        addCommand(Dictionary.TRANSLATE_CMD);
        addCommand(Dictionary.BACK_CMD);
        setCommandListener(this);
        Display.getDisplay(dictionary).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        if (c == Dictionary.BACK_CMD) {
            Display.getDisplay(dictionary).setCurrent(teach);
        } else if (c == Dictionary.TRANSLATE_CMD) {
            String key = getString().toLowerCase();
            if (key.length() != 0) 
            {
                setTitle(Locale.ONE_MINUTE);
                setString(Locale.SEARCHING);
                Vector selection = dictionary.getSelection(key);
                switch (selection.size()) { 
                case 0:
                    Alert a = new Alert(key, Locale.NO_VARIANTS, null, AlertType.ERROR);
                    a.setTimeout(Alert.FOREVER);
                    Display.getDisplay(dictionary).setCurrent(a, this);
                    break;
                case 1:
                    Translation t = (Translation)selection.firstElement();
                    if (t.word.equals(key)) { 
                        new TranslationBox(dictionary, this, (Translation)selection.firstElement());
                        break;
                    }
                default:
                    new PrefixList(dictionary, this, selection);
                    break;
                }
                setTitle(Locale.PREFIX);
                setString(key);
            }
        }
    }
}
