import java.util.*;
import java.io.*;

class Word implements Comparable { 
    String eng;
    String rus;
    int    engIndex;
    int    rusIndex;

    public int compareTo(Object o) { 
        return rus.compareTo(((Word)o).rus);
    }

    Word(String eng, String rus) { 
        this.eng = eng;
        this.rus = rus;
    }
};

public class Dictionary { 
    static final int MAX_FILE_SIZE = 8*1024;

    static final String OUTPUT = "..\\res\\";

    static int writeRusString(DataOutputStream out, String str) throws IOException { 
        byte[] bytes = str.getBytes();
        out.writeByte(bytes.length);
        out.write(bytes);
        return bytes.length + 1;
    }

    static int writeEngString(DataOutputStream out, String str) throws IOException { 
//        byte[] bytes = str.getBytes("ISO8859-2");
        byte[] bytes = str.getBytes();
        out.writeByte(bytes.length);
        out.write(bytes);
        return bytes.length + 1;
    }

    public static void main(String[] args) throws Exception {
//	BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream(args[0]), "ISO8859-2"));
//	BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream(args[0]), "UTF-16"));
	BufferedReader in = new BufferedReader(new FileReader(args[0]));
	String line;
        ArrayList words = new ArrayList();

	for (int i = 0; (line = in.readLine()) != null; i++) { 
            int tab = line.indexOf('\t');
            String eng = line.substring(0, tab).trim();
            String rus = line.substring(tab+1).trim();            
            if (eng.length() != 0 && rus.length() != 0) {                 
                int start = 0, comma;
                while ((comma = rus.indexOf(',', start)) >= 0) {
                    words.add(new Word(eng, rus.substring(start, comma).trim()));
                    start = comma + 1;
                }
                words.add(new Word(eng, rus.substring(start).trim()));
            }
	}
        Word[] rusSort = (Word[])words.toArray(new Word[words.size()]);
        Word[] engSort = (Word[])words.toArray(new Word[words.size()]);
        Arrays.sort(rusSort);

        for (int i = 1; i < rusSort.length; i++) { 
            if (rusSort[i].rus.equals(rusSort[i-1].rus)) {                 
                rusSort[i].rusIndex = rusSort[i-1].rusIndex;
            } else { 
                rusSort[i].rusIndex = i;
            }
        }

	DataOutputStream index = new DataOutputStream(new FileOutputStream(OUTPUT + "eng.idx"));
	DataOutputStream out = new DataOutputStream(new FileOutputStream(OUTPUT + "eng.1"));
	int size = 0;
        int id = 1;
        String prevWord = null;
	for (int i = 0; i < engSort.length; i++) { 
	    Word word = engSort[i];
            String thisWord = word.eng;
            if (thisWord.equals(prevWord)) { 
                word.engIndex = engSort[i-1].engIndex;
            } else {
                word.engIndex = i;
            }
            if (prevWord == null) {
                size += writeEngString(out, thisWord) + 4;
                out.writeInt(word.rusIndex);
            } else { 
                int prefix;
                int len = thisWord.length() > prevWord.length() ? prevWord.length() : thisWord.length();
                if (len > ' ') { 
                    len = ' ';
                }
                for (prefix = 0; prefix < len && thisWord.charAt(prefix) == prevWord.charAt(prefix); prefix++);
                String pw = thisWord;
                if (prefix > 0) { 
                    pw = (char)prefix + pw.substring(prefix);
                }
                if (size + pw.length() + 5 > MAX_FILE_SIZE) { 
                    writeEngString(index, prevWord);
                    index.writeInt(i-1);                
                    out.close();
                    out = new DataOutputStream(new FileOutputStream(OUTPUT + "eng." + ++id));
                    size = 0;
                }
                size += writeEngString(out, pw) + 4;
                out.writeInt(word.rusIndex);
            }
            prevWord = thisWord;
	}
        writeEngString(index, prevWord);
        index.writeInt(engSort.length-1);                
	out.close();
        index.close();

	index = new DataOutputStream(new FileOutputStream(OUTPUT + "rus.idx"));
	out = new DataOutputStream(new FileOutputStream(OUTPUT + "rus.1"));
	size = 0;
        id = 1;
        prevWord = null;
	for (int i = 0; i < rusSort.length; i++) { 
	    Word word = rusSort[i];
            String thisWord = word.rus;
            if (prevWord == null) {
                size += writeRusString(out, thisWord) + 4;
                out.writeInt(word.engIndex);
            } else { 
                int prefix;
                int len = thisWord.length() > prevWord.length() ? prevWord.length() : thisWord.length();
                if (len > ' ') { 
                    len = ' ';
                }
                for (prefix = 0; prefix < len && thisWord.charAt(prefix) == prevWord.charAt(prefix); prefix++);
                String pw = thisWord;
                if (prefix > 0) { 
                    pw = (char)prefix + pw.substring(prefix);
                }
                if (size + pw.length() + 5 > MAX_FILE_SIZE) { 
                    writeRusString(index, prevWord);
                    index.writeInt(i-1);
                    out.close();
                    out = new DataOutputStream(new FileOutputStream(OUTPUT + "rus." + ++id));
                    size = 0;
                }
                size += writeRusString(out, pw) + 4;
                out.writeInt(word.engIndex);
            }
            prevWord = thisWord;
	}
        writeRusString(index, prevWord);
        index.writeInt(rusSort.length-1);
	out.close();
        index.close();
    }
}